#include "testlib.h"
#include <sstream>
#include <cstring>

using namespace std;

string ending(long long x)
{
    x %= 100;
    if (x / 10 == 1)
        return "th";
    if (x % 10 == 1)
        return "st";
    if (x % 10 == 2)
        return "nd";
    if (x % 10 == 3)
        return "rd";
    return "th";
}

string ltoa(long long n)
{
    stringstream ss;
    ss << n;
    string result;
    ss >> result;
    return result;
}

struct Num
{
	int len_;
	vector<int> digits_;
	Num()
	: len_(0)
	{}
	
	void operator = (const Num &b)
	{
		len_= b.len_;
		digits_ = b.digits_;
		//cout<<"*\n";
	}
	
	void operator = (const int b)
	{
		int t = b;
		for (digits_.clear(), len_ = 0; t > 0; t /= 10, len_++)
		{
			digits_.push_back(t % 10);
		}
		//cout<<"len_="<<len_<<"\n";
	}
	
	void operator *= (const Num &b)
	{
		if (b.len_ == 0)
		{
			digits_.clear();
			len_ = 0;	
			return;
		}
		int length = len_ + b.len_;
		vector<int> ans(length, 0);
		
		for(int i = 0; i < len_; ++i)
		{
			int t = 0;	
			for(int j = 0; j < b.len_; ++j)	
			{
				t = digits_[i] * b.digits_[j] + ans[i + j];
				ans[i + j] = t % 10; 
				t /= 10; 
			}
			if(t)
				ans[b.len_ + i] = t % 10; 
		}
    	if(ans[length - 1] == 0)
		{
			len_ = length - 1;
		} 
		else
		{
			len_=  length;	
		}
		digits_ = ans;	
		//cout<<"*len_="<<len_<<"\n";
    }
	
	friend bool operator < (const Num &a, const Num &b)
	{
		if (a.len_ ^ b.len_)
			return a.len_ < b.len_;
			
		for (int i = a.len_ - 1; i >= 0; i++)
		{
			if (a.digits_[i] ^ b.digits_[i])
				return a.digits_[i] < b.digits_[i];
		}
		return false;	
	}
	
	friend ostream &operator << (ostream &out, const Num &a)
	{
		if(a.len_  == 0)
			out<<"0";
		else
			for (int i = a.len_ - 1; i >= 0 ;i--)
			{
				out << a.digits_[i];
			}
		return out;	
	}
	
	void print(char*s)
	{
		if(len_  == 0)
			s[0] ='0';
		else
			for (int i = len_ - 1; i >= 0 ;i--)
			{
				s[len_ -  i - 1] = '0' + digits_[i];
			}
	}
};

int main(int argc, char * argv[])
{
    setName("checker", 8 * sizeof(long long));

    registerTestlibCmd(argc, argv);

    int n = inf.readInt(1, 200);
    
    int sum_out = 0;
    Num out_v;
    out_v = 1;
    while (!ouf.seekEof())
    {
	int t = ouf.readInt(1, n);
	sum_out += t;
	if(sum_out > n)
	    quitf(_wa, "sum_out %d != n", sum_out);
	Num lt;
	lt = t;
	out_v *= lt;   
    }
    if(sum_out != n)
	quitf(_wa, "sum_out %d != n", sum_out);
    
    int sum_ans = 0;
    Num ans_v;
    ans_v = 1;
    
    while (!ans.seekEof())
    {
	int t = ans.readInt(1, n);
	sum_ans += t;
	if(sum_ans > n)
	    quitf(_wa, "sum_ans %d != n", sum_ans);
	Num lt;
	lt = t;
	ans_v *= lt;   
    }
    if(sum_ans != n)
	quitf(_wa, "sum_ans %d != n", sum_out);

    char s1[1000] = "", s2[1000] = "";
    out_v.print(s1);
    ans_v.print(s2);    
    if ( strcmp(s1, s2) !=0 ) 
	quitf(_wa, "production_out %s !=  production_ans %s", s1, s2);
    else
	quitf(_ok,"OK");
}