#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;

const int MAX = 50005;

struct Edge {
    int to, limit;
    Edge(int to_ = 0, int limit_ = 0) : to(to_), limit(limit_) {}
};

int n, m, k;
vector <Edge> v[MAX];
bool used[MAX];

int reachable(int node, int limit, int blocked) {
    int ret = 1;
    used[node] = true;
    for (int i = 0; i < (int)v[node].size(); i++)
        if (v[node][i].to != blocked && !used[v[node][i].to] && limit < v[node][i].limit)
            ret += reachable(v[node][i].to, limit, blocked);
    return ret;
}

bool connected(int snow) {
    memset(used, 0, sizeof(used));
    return reachable(0, snow, -1) == n;
}

vector <int> getDangerousSlow(int snow) {
    vector <int> dangerous;
    for (int blocked = 0; blocked < n; blocked++) {
        memset(used, 0, sizeof(used));
        if (reachable(!blocked, snow, blocked) < n - 1)
            dangerous.push_back(blocked);
    }
    return dangerous;
}

pair <int, vector <int>> dummy() {
    for (int snow = 0; ; snow++) {
        if (!connected(snow))
            return make_pair(-1, vector<int>());
        vector <int> dangerous = getDangerousSlow(snow);
        if ((int)dangerous.size() >= k)
            return make_pair(snow, dangerous);
    }
}

int main(void) {
    scanf("%d %d %d", &n, &m, &k);
    for (int i = 0; i < m; i++) {
        int node1, node2, limit;
        scanf("%d %d %d", &node1, &node2, &limit);
        node1--, node2--;
        v[node1].push_back(Edge(node2, limit));
        v[node2].push_back(Edge(node1, limit));
    }
 
    pair <int, vector<int>> ans = dummy();
    printf("%d %d\n", ans.first, (int)ans.second.size());
    for (int i = 0; i < (int)ans.second.size(); i++)
        printf("%d%c", ans.second[i] + 1, i + 1 == (int)ans.second.size() ? '\n' : ' ');

    return 0;
}
